<?PHP

# Фильтруем числа
function num($var)
{
 $var = abs(intval($var));
  return $var;
}

# Фильтруем текст
function text($var)
{
 $var = trim($var);
 $var = mysql_real_escape_string($var);
 $var = htmlspecialchars($var, ENT_QUOTES, 'UTF-8');
   return $var;
}

# Выводим текс в браузер
function on_text($var)
{
 $var = trim($var);
 $var = htmlspecialchars($var, ENT_QUOTES, 'UTF-8');
   return $var;
}

# Вывод ошибок
function error($text)
{
 ?><div class="error"><?=$text?></div><?
}

# Вывод сообщений
function message($text)
{
 ?><div class="message"><?=$text?></div><?
}


# Переносы строк (взята из DCMS 6.6.4
function br($msg,$br='<br />'){return preg_replace("#((<br( ?/?)>)|\n|\r)+#i",$br, $msg);}

function esc($text,$br=NULL){ // Вырезает все нечитаемые символы
if ($br!=NULL)
for ($i=0;$i<=31;$i++)$text=str_replace(chr($i), NULL, $text);
else{
for ($i=0;$i<10;$i++)$text=str_replace(chr($i), NULL, $text);
for ($i=11;$i<20;$i++)$text=str_replace(chr($i), NULL, $text);
for ($i=21;$i<=31;$i++)$text=str_replace(chr($i), NULL, $text);}
return $text;}


# функция обрабатывает текстовые строки перед выводом в браузер (взята из DCMS 6.6.4)
function onl_text($str,$br=true,$html=true)
{
if ($html==true)
$str=htmlentities($str, ENT_QUOTES, 'UTF-8'); // преобразуем все к нормальному перевариванию браузером

if ($br==true)
{
$str=br($str); // переносы строк
$str=esc($str); // вырезаем все нечитаемые символы, которые могут нам подпортить разметку :)
}
else
{
//$str=br($str, ' '); // пробелы вместо переносов
$str=esc($str); // вырезаем все нечитаемые символы, которые могут нам подпортить разметку :)
}
return $str; // возвращаем обработанную строку
}



# Транслит URL
function translitit($str)
{
    $tr = array(
        "А"=>"a","Б"=>"b","В"=>"v","Г"=>"g",
        "Д"=>"d","Е"=>"e","Ж"=>"j","З"=>"z","И"=>"i",
        "Й"=>"y","К"=>"k","Л"=>"l","М"=>"m","Н"=>"n",
        "О"=>"o","П"=>"p","Р"=>"r","С"=>"s","Т"=>"t",
        "У"=>"u","Ф"=>"f","Х"=>"h","Ц"=>"ts","Ч"=>"ch",
        "Ш"=>"sh","Щ"=>"sch","Ъ"=>"","Ы"=>"yi","Ь"=>"",
        "Э"=>"e","Ю"=>"yu","Я"=>"ya","а"=>"a","б"=>"b",
        "в"=>"v","г"=>"g","д"=>"d","е"=>"e","ж"=>"j",
        "з"=>"z","и"=>"i","й"=>"y","к"=>"k","л"=>"l",
        "м"=>"m","н"=>"n","о"=>"o","п"=>"p","р"=>"r",
        "с"=>"s","т"=>"t","у"=>"u","ф"=>"f","х"=>"h",
        "ц"=>"ts","ч"=>"ch","ш"=>"sh","щ"=>"sch","ъ"=>"y",
        "ы"=>"yi","ь"=>"","э"=>"e","ю"=>"yu","я"=>"ya", 
        " "=> "_", "."=> "_", "/"=> "_"
    );
    return strtr($str,$tr);
}






# Проверка длины строки (Функция взята из Dcms 6.6.4)
function strlen2($str)
{
$rus = array('й','ц','у','к','е','н','г','ш','щ','з','х','ъ','ф','ы','в','а','п','р','о','л','д','ж','э','я','ч','с','м','и','т','ь','б','ю','Й','Ц','У','К','Е','Н','Г','Ш','Щ','З','Х','Ъ','Ф','Ы','В','А','П','Р','О','Л','Д','Ж','Э','Я','Ч','С','М','И','Т','Ь','Б','Ю');
return strlen(str_replace($rus, '0', $str));
}

# Вытаскиваем IP пользователя
function GetRealIp() {

 if(!empty($_SERVER['HTTP_CLIENT_IP'])) $ip = $_SERVER['HTTP_CLIENT_IP'];
 elseif(!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
 else $ip = $_SERVER['REMOTE_ADDR'];

 $ip = explode(',', $ip);

 return $ip[0];
}




# Вывод времени
function on_time($var)
{
	if ($var == NULL) $var = time();
	$full_time = date('d.m.Y в H:i', $var);
	$date = date('d.m.Y', $var);
	$time = date('H:i', $var);
	if ($date == date('d.m.Y')) $full_time = date('Сегодня в H:i', $var);
	if ($date == date('d.m.Y', time()-60*60*24)) $full_time = date('Вчера в H:i', $var);
	return $full_time;
}

# Блокировка ссылок
function antilink($var) {

$var = preg_replace('~\\[url=(https?://.+?)\\](.+?)\\[/url\\]|(https?://(www.)?[0-9a-z\.-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', '[реклама]', $var);
$replace = array(
'.ru' => '***',
'.рф' => '***',
'.us' => '***',
'.su' => '***',
'.com' => '***',
'.biz' => '***',
'.cn' => '***',
'.in' => '***',
'.net' => '***',
'.org' => '***',
'.info' => '***',
'.mobi' => '***',
'.kmx' => '***',
'.h2m' => '***',
'.net' => '***',

);

return strtr($var, $replace);
}
#ББ коды
function bbcode($var, $url = FALSE) {

$search = array(
'#\[b](.+?)\[/b]#is',
'#\[i](.+?)\[/i]#is',
'#\[red](.+?)\[/red]#is',
'#\[green](.+?)\[/green]#is',
'#\[blue](.+?)\[/blue]#is'
);

$replace = array(
'<span style="font-weight: bold">$1</span>',
'<span style="font-style: italic">$1</span>',
'<span style="color: red">$1</span>',
'<span style="color: green">$1</span>',
'<span style="color: blue">$1</span>'
);

if($url) {
$search[] = '#\[url=(.+?)](.+?)\[/url]#is';
$replace[] = '<a href="$1">$2</a>';
}

return preg_replace($search, $replace, $var);
}
# Смайлы
function smiles($str) {

$smiles = array(
':)' => '<img src="/design/smiles/smile.gif" alt=":)">',
';)' => '<img src="/design/smiles/wink.gif" alt=";)">',
':D' => '<img src="/design/smiles/biggrin.gif" alt=":D">',
':P' => '<img src="/design/smiles/p.gif" alt=":P">',
'.like.' => '<img src="/design/smiles/like.gif" alt=".like.">',
'.zol.' => '<img src="/design/smiles/zol.gif" alt=".zol.">'
);


return strtr($str, $smiles);
}

?>